/* Die folgenden Code-Beispiele stammen aus dem Buch:
 *  Objektorientiertes Programmieren in C++
 *   Ein Tutorial fr Ein- und Umsteiger
 * von Nicolai Josuttis, Addison-Wesley Mnchen, 2001
 *
 * (C) Copyright Nicolai Josuttis 2001.
 * Diese Software darf kopiert, verwendet, modifiziert und verteilt
 * werden, sofern diese Copyright-Angabe in allen Kopien vorhanden ist.
 * Diese Software wird "so wie sie ist" zur Verfgung gestellt.
 * Es gibt keine explizite oder implizite Garantie ber ihren Nutzen.
 */
// mgliche Implementierung von Operator new
void* operator new (std::size_t size)
{
    void* p;        // Zeiger fr neuen Speicher

    // solange es nicht klappt, neuen Speicher zu bekommen,
    // New-Handler aufrufen oder Ausnahme auslsen
    while ((p = holSpeicher(size)) == 0) {
        // kein ausreichender Speicherplatz verfgbar
        if (MyNewHandler != 0) {
              // New-Handler aufrufen
              (*myNewHandler)();
        }
        else {
              // Ausnahme auslsen
              throw std::bad_alloc();
        }
    }

    // OK, neuen Speicherplatz zurckliefern
    return p;
}
