/* Die folgenden Code-Beispiele stammen aus dem Buch:
 *  Objektorientiertes Programmieren in C++
 *   Ein Tutorial fr Ein- und Umsteiger
 * von Nicolai Josuttis, Addison-Wesley Mnchen, 2001
 *
 * (C) Copyright Nicolai Josuttis 2001.
 * Diese Software darf kopiert, verwendet, modifiziert und verteilt
 * werden, sofern diese Copyright-Angabe in allen Kopien vorhanden ist.
 * Diese Software wird "so wie sie ist" zur Verfgung gestellt.
 * Es gibt keine explizite oder implizite Garantie ber ihren Nutzen.
 */
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

int main()
{
    std::vector<std::string> menge;            // Container fr Strings
    std::vector<std::string>::iterator pos;    // Iterator

    // Verschiedene Stdtenamen einfgen
    menge.push_back("Hamburg");
    menge.push_back("Mnchen");
    menge.push_back("Berlin");
    menge.push_back("Braunschweig");
    menge.push_back("Duisburg");
    menge.push_back("Leipzig");

    // alle Elemente aufsteigend sortieren
    std::sort (menge.begin(), menge.end());

    /* "Hannover" vor "Hamburg" einfgen
     * - Position von "Hamburg" suchen
     * - "Hannover" davor einfgen
     */
    pos = find (menge.begin(), menge.end(),    // Bereich
                "Hamburg");                    // Suchkriterium
    if (pos != menge.end()) {
        menge.insert(pos,"Hannover");
    }
    else {
        std::cerr << "Huch, Hamburg ist gar nicht vorhanden"
                  << std::endl;
        menge.push_back("Hannover");
    }

    // alle Elemente ausgeben
    for (pos=menge.begin(); pos!=menge.end(); ++pos) {
        std::cout << *pos << ' ';
    }
    std::cout << std::endl;
}
